#!/bin/bash

MOTD="/etc/motd"

# Check for only the supported versions
# Assumes version numbers are #.#.# with no double digits or letters
if [[ -e $MOTD ]] ; then
    cat $MOTD | grep "Version [5-9][.].[.]."
    if [[ "$?" -ne "0" ]] ; then
            exit 1
    fi
else
    # If /etc/motd does not exist this is a unrecoverable failure
    # return the unit to the factory
    exit 1
fi

UPGRADE_DIR="/opt/upgrade/temp"

install -o root -g root -m 777 ${UPGRADE_DIR}/wermit /bin/
install -o root -g root -m 777 ${UPGRADE_DIR}/setserial /bin/
install -o root -g root -m 777 ${UPGRADE_DIR}/wermit /bin/
install -o root -g root -m 777 ${UPGRADE_DIR}/stl_update.ck /bin/

chmod +x ${UPGRADE_DIR}/stl_update.sh
${UPGRADE_DIR}/stl_update.sh ${UPGRADE_DIR}/evk2-bundle-3.6.17.tar.gz &>> /home/spectracom/log/stl_update.log
