#!/bin/wermit +
echo "Configuring serial port"
set modem type none
set line /dev/ttyS3
set speed 115200
set carrier-watch off
set flow-control none
set transfer mode manual
set file type binary
set window 1
set send pause 50
set transfer slow-start off
set output pacing 100
set retry 250
set receive packet-length 1000
set send packet-length 1000
set transaction-log verbose
log transactions /home/spectracom/log/stl_xfer.log

; Log in if needed
echo "Logging in"

clear
output \13
minput 5 {login:} {root@}
switch \v(minput) {
    :1,
        output root\13,
        input 10 Password:,
        output Spectracom$\%3\13,
        break
    :2,
        echo {already logged in},
        break
}

clear
; Set up for receiving
echo
echo "Preparing for file transfer"
output cd /media/mmcblk0p1\13
input 10 /media/mmcblk0p1#
IF FAIL EXIT 1 "Failed to change to upgrade directory"


output rm *\13
input 10 /media/mmcblk0p1#
IF FAIL EXIT 2 "Failed to cleanup upgrade directory"

assign \%c 0
:RETRYSEND
echo "Attempting file transfer"
output ek -r -R -B\13
pause 3
clear
output \13
; make sure it's actually running before trying to send
; success in this case means that ek is not running properly
; a failure (timeout) likely means that kermit is running on the card
input 10
IF SUCCESS {
    increment \%c
    if < \%c 5 GOTO RETRYSEND
    EXIT 2 "Could not execute transfer"
}

echo sending bundle: \%1/\%2
echo Beginning transfer: \v(time)
msend /filenames:literal \%1/install.sh \%1/\%2 
; Install bundle
echo "Transfer complete: \v(time)"

input 10 /media/mmcblk0p1#
IF FAIL EXIT 3 Terminal unresponsive
echo

output chmod +x install.sh\13
input 10 /media/mmcblk0p1#
IF FAIL EXIT 3 Terminal unresponsive

assign \%r 0
while < \%r 3 {
    echo "Installing software"
    output ./install.sh\13
    minput 900 {Upgrade complete} {Upgrade failed} {Transfer failed}
    switch \v(minput) {
        :1,
            echo,
            echo {Upgrade successful},
            quit 0
        :2,
            echo,
            echo {Upgrade failed},
            quit 1
        :3,
            echo,
            echo {Transfer failed - attempting retransfer},
            assign \%c 0
            :RETRYSEND2
            echo "Attempting file retransfer"
            output ek -r -R -B\13
            pause 3
            clear
            output \13
            ; make sure it's actually running before trying to send
            ; success in this case means that ek is not running properly
            ; a failure (timeout) likely means that kermit is running on the card
            input 10
            IF SUCCESS {
                increment \%c
                if < \%c 5 GOTO RETRYSEND2
                EXIT 2 "Could not execute transfer"
            }

            echo Beginning transfer: \v(time),
            msend /filenames:literal \%1/\%2 ,
            echo "Transfer complete: \v(time)",
            echo,
            input 10 /media/mmcblk0p1#,
            break
    }
    increment \%r
    pause 3
}
echo "Failed to send bundle \%r times"
quit 2

